importPackage(Packages.org.csstudio.platform.data);
importPackage(Packages.org.csstudio.opibuilder.scriptUtil);

/*
input:
0 - ROI3 min RBV scalar
1 - ROI3 X size RBV scalar
2 - ROI3 binning RBV scalar
3 - ROI2 min RBV scalar
4 - ROI2 Array size RBV scalar (trig)
5 - ROI2 binning RBV scalar
6 - ST3 flat top maximum value scalar
7 - ROI3 Array size RBV scalar (trig only)

We need to make sure that the cursors always point to the right part
of the trace, no matter what ROI & binning is used, if user zooms in/out,
if auto zooming is used, if is graph reset,..

With out limit points auto zoom does not show the complete pulse or
cursors in the right place after user zooms, auto-zooms,..

ROI3 is applied to flat top chain.
It is also used to position the cursors on a whole pulse graph.
ROI2 is applied to whole pulse chain.
It is also used to position the cursor limits on a whole pulse graph.
*/

var values = false;
// this one usually fails with 
// JavaException: java.lang.NullPointerException: PV LAB-090Row:PBI-AMC-011:1-ST3-MaxValue_RBV has no value.
// after OPI load/reload.
try {
	var traceMax = PVUtil.getDouble(pvs[6]);
	// ConsoleUtil.writeInfo("traceMax: "+traceMax);
} catch (e) {
	// ConsoleUtil.writeInfo("ERR: caught " + e);
	var traceMax = 100;
}

try {
	// var traceMax = PVUtil.getDouble(pvs[6]);
	var roi3Min = parseInt(PVUtil.getDouble(pvs[0]));
	var roi3XSize = parseInt(PVUtil.getDouble(pvs[1]));
	var roi3Bin = parseInt(PVUtil.getDouble(pvs[2]));
	var roi3End = roi3Min + roi3XSize;
	// ConsoleUtil.writeInfo("ROI3 min..end: "+roi3Min+'..'+roi3End+'( bin:'+roi3Bin+')');
	var cursorX = DataUtil.createDoubleArray(4);
	cursorX[0] = roi3Min;
	cursorX[1] = roi3Min;
	cursorX[2] = roi3End;
	cursorX[3] = roi3End;
	var cursorY = DataUtil.createDoubleArray(4);
	cursorY[0] = 0 - (traceMax*0.05);
	cursorY[1] = traceMax+(traceMax*0.05);
	cursorY[2] = 0 - (traceMax*0.05);
	cursorY[3] = traceMax+(traceMax*0.05);

	var roi2Min = parseInt(PVUtil.getDouble(pvs[3]));
	var roi2Size = parseInt(PVUtil.getDouble(pvs[4]));
	var roi2Bin = parseInt(PVUtil.getDouble(pvs[5]));
	var roi2End = roi2Min + roi2Size; 
	// ConsoleUtil.writeInfo("ROI2 min..end: "+roi2Min+'..'+roi2End+'( bin:'+roi2Bin+')');
	var limitX = DataUtil.createDoubleArray(6);
	limitX[0] = roi2Min;
	limitX[1] = roi2Min;
	limitX[2] = roi2End;
	limitX[3] = roi2End;
	limitX[4] = roi2Min-1;
	limitX[5] = roi2End+1;

	var limitY = DataUtil.createDoubleArray(6);
	limitY[0] = 0 - (traceMax*0.05);
	limitY[1] = traceMax+(traceMax*0.05);
	limitY[2] = 0 - (traceMax*0.05);
	limitY[3] = traceMax+(traceMax*0.05);
	limitY[4] = 0;
	limitY[5] = 0;
	values = true;
} catch (e) {
	// ConsoleUtil.writeInfo("ERR: caught " + e);
}

if (values) {
	try {
		PVUtil.writePV("loc://cur_x", cursorX);
		PVUtil.writePV("loc://cur_y", cursorY);
		PVUtil.writePV("loc://lim_x", limitX);
		PVUtil.writePV("loc://lim_y", limitY);
		// ConsoleUtil.writeInfo("refreshed cursors and limits..");
	} catch (e) {
		ConsoleUtil.writeInfo("ERR: caught" + e);
	}
}
